package de.telefonbuch.model;

import org.jetbrains.annotations.NotNull;

import java.rmi.NotBoundException;
import java.rmi.RemoteException;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;

public class Client {

	IServer server;

	public Client(String ipaddress) throws RemoteException, NotBoundException {
		// Registry holen, wenn sie sich auf demselben Rechner befindet
		Registry registry = LocateRegistry.getRegistry(Registry.REGISTRY_PORT);

		// Entferntes Objekt laden
		this.server = (IServer) registry.lookup("RMI-Server");

	}

	public void addKontakt(@NotNull Kontakt kontakt) {
		try {
			server.addKontakt(kontakt);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	public void deleteKontakt(String telefon) {
		try {
			server.deleteKontakt(telefon);
		} catch (RemoteException e) {
			e.printStackTrace();
		}
	}

	public Kontakt getKontakt(@NotNull String telefon) {
		Kontakt kontakt = null;

		try {
			kontakt = server.getKontakt(telefon);
		} catch (RemoteException e) {
			e.printStackTrace();
		}

		return kontakt;
	}

	public String[] getNavi(String telefon) {
		String[] result = new String[0];

		try {
			result = server.getNavi(telefon);
		} catch (RemoteException e) {
			e.printStackTrace();
		}

		return result;
	}

	public int countKontakte() {
		int i = 0;

		try {
			i = server.countKontakte();
		} catch (RemoteException e) {
			e.printStackTrace();
		}

		return i;
	}
}
