package de.telefonbuch.model;

/**
 * Das Model für die Kontakte
 */
public class Kontakt {
	// region 0 Variables
	private String vorname = "";
	private String nachname = "";
	private String strasse = "";
	private String hausnummer = "";
	private String plz = "";
	private String ort = "";
	private String telefon = "";
	private String id = "";
	//endregion

	// region 1 Konstruktor
	public Kontakt() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true);
	}
	// endregion

	// region 2 Setter
	/**
	 * Setzt den Vornamen. Dieser darf maximal 50 Zeichen lang sein
	 * Gibt im erfolgs Fall true und bei einem Fehler false zurück
	 * @param vorname : String
	 * @return boolean
	 */
	public boolean setVorname(String vorname) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		if (vorname  != null && vorname.length() <= 50) {
			this.vorname = vorname;
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Setzt den Nachnamen. Dieser darf maximal 50 Zeichen lang sein
	 * Gibt im erfolgs Fall true und bei einem Fehler false zurück
	 * @param nachname : String
	 * @return boolean
	 */
	public boolean setNachname(String nachname) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		if (nachname  != null && nachname.length() <= 50) {
			this.nachname = nachname;
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Setzt die Straße. Diese darf maximal 50 Zeichen lang sein
	 * Gibt im erfolgs Fall true und bei einem Fehler false zurück
	 * @param strasse : String
	 * @return boolean
	 */
	public boolean setStrasse(String strasse) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		if (strasse  != null && strasse.length() <= 50) {
			this.strasse = strasse;
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Setzt die Hausnummer. Diese darf maximal 10 Zeichen lang sein
	 * Gibt im erfolgs Fall true und bei einem Fehler false zurück
	 * @param hausnummer : String
	 * @return boolean
	 */
	public boolean setHausnummer(String hausnummer) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		if (hausnummer != null && hausnummer.length() <= 10) {
			this.hausnummer = hausnummer;
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Setzt die Postleitzahl. Diese muss genau 5 Zeichen lang sein
	 * Gibt im erfolgs Fall true und bei einem Fehler false zurück
	 * @param plz : String
	 * @return boolean
	 */
	public boolean setPlz(String plz) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		if (plz != null && plz.length() == 5) {
			this.plz = plz;
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Setzt den Ort. Dieser darf maximal 50 Zeichen lang sein
	 * Gibt im erfolgs Fall true und bei einem Fehler false zurück
	 * @param ort : String
	 * @return boolean
	 */
	public boolean setOrt(String ort) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		if (ort != null && ort.length() <= 50) {
			this.ort = ort;
			return true;
		} else {
			return false;
		}
	}

	/**
	 * Setzt die Telefonnummer. Diese muss zwischen 3 und 50 Zeichen lang sein
	 * Gibt im erfolgs Fall true und bei einem Fehler false zurück
	 * @param telefon : String
	 * @return boolean
	 */
	public boolean setTelefon(String telefon) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		if (telefon != null && telefon.length() <= 30 && telefon.length() > 2 && isNumeric(telefon)) {
			this.telefon = telefon;
			return true;
		} else {
			return false;
		}
	}
	//endregion

	// region 3 Getter
	/**
	 * Gibt den Vornamen zurück
	 * @return : String
	 */
	public String getVorname() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return vorname;
	}

	/**
	 * Gibt den Nachnamen zurück
	 * @return : String
	 */
	public String getNachname() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return nachname;
	}

	/**
	 * Gibt die Straße zurück
	 * @return : String
	 */
	public String getStrasse() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return strasse;
	}

	/**
	 * Gibt die Hausnummer zurück
	 * @return : String
	 */
	public String getHausnummer() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return hausnummer;
	}

	/**
	 * Gibt die Postleitzahl zurück
	 * @return : String
	 */
	public String getPlz() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return plz;
	}

	/**
	 * Gibt den Ort zurück
	 * @return : String
	 */
	public String getOrt() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return ort;
	}

	/**
	 * Gibt die Telefonnummer zurück
	 * @return : String
	 */
	public String getTelefon() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return telefon;
	}
	//endregion

	//region 4 Functions
	/**
	 * Prueft ob der String ausschließlich aus Zahlen besteht
	 */
	private boolean isNumeric(String s) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return s != null && s.matches("[-+]?\\d*\\.?\\d+");
	}

	String getId() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return id;
	}

	public void setId(String id) {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		this.id = id;
	}

	@Override
	public String toString() {
		new Fehler().debug(this.getClass().getName() + "." + new Throwable().getStackTrace()[0].getMethodName(), true, 3);

		return "Vorname: " + this.getVorname() +
				" Nachname: " + this.getNachname() +
				" Straße: " + this.getStrasse() +
				" Hnr: " + this.getHausnummer() +
				" Plz: " + this.getPlz() +
				" Ort: " + this.getOrt() +
				" Telefon: " + this.getTelefon();
	}
	//endregion
}
